scope-specific-bid-forms/{formId}
Updates the specified scope specific bid form by replacing the current line items with the line items specified in the body of the request. Since this is a replace operation, all line items must be provided, including ones which have not been changed.
Resource Information
| Method and URI | PATCH https://developer.api.autodesk.com/construction/buildingconnected/v2/scope-specific-bid-forms/{formId} |
| Authentication Context | User context required |
| Required OAuth Scopes | data:write |
| Data Format | JSON |
Request
Headers
| Authorization* string | Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow. |
| Content-Type* string | Must be application/json |
Request
URI Parameters
| formId string | The ID of the form. |
Request
Body Structure
| includeSectionHeaders boolean | If true, any line items with a null description and a non-empty section will be treated as a section header.
This is the only way to create section headers which don’t have any line items belonging to the section. Also, the response will include all of the section headers of the updated bid form as line items with a null description and the section name in the |
| lineItems array: object | An array of scope-specific bid form line items.
Note that bid form’s line items must each have a unique combination of Max 2000 bid form line items. |
| id string | The ID of an existing line item if it is being updated, not created.
Max length: 24 |
| type* enum:string | The type of the scope-specific bid form line item.
The possible values have the following UI equivalents:
|
| description* string | A description of the scope-specific bid form line item. |
| section string | The user-defined name of an optional section of the scope-specific bid form that the line item is in. If the section does not exist, a new section is created automatically. This value should be null if the item is not in a section.
Note that all of the line items for which you provide the same section value will be in the same section. |
| isRequired boolean | Indicates whether the scope-specific line item is required in bids. Possible values:
|
| unit enum:string | The unit format of the scope-specific line item.
The possible values of this field depend on the value of
Note that the value |
| code string | The cost code associated with the scope-specific line item.
Max length: 87 |
| quantity number | The quantity of the scope-specific line item. This value is null under either of the following conditions:
|
| isQuantityFixed boolean | Indicates whether the scope-specific line item quantity is fixed. If it is fixed, bidders cannot change it. Possible values:
|
| external object | Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.
Note that BuildingConnected does not use the information in this object. |
| id* string | A user-provided ID of the external tool. |
| name string | A user-provided name for the external tool. |
Response
HTTP Status Code Summary
| 200 OK | Success |
| 400 Bad Request | The parameters of the requested operation are invalid. |
| 401 Unauthorized | The provided bearer token is not valid. |
| 403 Forbidden | The user or service represented by the bearer token does not have permission to perform this operation. |
| 404 Not Found | The requested resource could not be found. |
| 429 Too Many Requests | Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait. |
| 500 Internal Server Error | An unknown error occurred on the server. |
Response
Body Structure (200)
| id string | The ID of the scope-specific bid form.
Max length: 24 |
| projectId string | The ID of the project that the bid form addresses.
Max length: 24 |
| currentAccLinkedProjectId string | The ID of an ACC project linked with this bid form’s project. |
| bidPackageId string | The ID of the bid package that the bid form addresses.
Max length: 24 |
| createdBy string | The ID of the user who created the scope-specific bid form.
Max length: 24 |
| updatedBy string | The ID of the user who last updated the scope-specific bid form.
Max length: 24 |
| createdAt datetime: ISO 8601 | The date and time that the scope-specific form was created, in ISO 8601 format. |
| updatedAt datetime: ISO 8601 | The date and time that the scope-specific form was last updated, in ISO 8601 format. |
| isTemplate boolean | Indicates whether this bid form a is a template or an actual scope-specific bid form for a project.
|
| lineItems object | A paginated list of the bid form’s line items.
Max 100 line items per page. |
| pagination object | The pagination details of a response. |
| limit int | The maximum number of records to return per page.
Note that a returned page may contain fewer records than the limit under either of these conditions:
|
| cursorState string | An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.
Omit this parameter to initiate a paginated request or to restart pagination. |
| nextUrl string | The URL path that returns the next page of data. |
| results array: object | The array of bid form line items |
| id string | The unique ID of the scope-specific line item.
Max length: 24 |
| type enum:string | The type of the scope-specific line item.
The possible values have the following UI equivalents:
|
| description string | A description of the scope-specific line item. |
| section string | The section that the scope-specific line item is under. This value is null if the item is not under a section. |
| isRequired boolean | Indicates whether the scope-specific line item is required. Possible values:
|
| unit enum:string | The unit format of the scope-specific line item.
The possible values of this field depend on the value of
Note that the value |
| code string | The cost code associated with the scope-specific line item. |
| quantity number | The quantity of the scope-specific line item. This value is null under either of the following conditions:
|
| isQuantityFixed boolean | Indicates whether the scope-specific line item quantity is fixed. If it is fixed, bidders cannot change it. Possible values:
|
| external object | Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.
Note that BuildingConnected does not use information in this object. |
| id string | The ID of the external tool. |
| name string | The name of the external tool. |
Example
Success
Request
curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/scope-specific-bid-forms/:formId' \
-X 'PATCH' \
-H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
-H 'Content-Type: application/json' \
-d '{
"includeSectionHeaders": "",
"lineItems": [
{
"id": "53811754d3a604966df72247",
"type": "COST_BREAKDOWN",
"description": "Duct Insulation",
"section": "Furnish & Install",
"isRequired": true,
"unit": "HOURS",
"code": "D2",
"quantity": 1000,
"isQuantityFixed": true,
"external": {
"id": "ext-cost-id-123",
"name": "External Cost Code"
}
}
]
}'
Response
{
"id": "5af0892518d349f6d59e1bbb",
"projectId": "59d2bd7440b36a0da258f24d",
"currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
"bidPackageId": "590dd127b359f408f190b5a7",
"createdBy": "5542856b27aae240452fce62",
"updatedBy": "5542856b27aae240452fce62",
"createdAt": "2021-08-19T23:07:16.083Z",
"updatedAt": "2021-08-20T23:07:16.083Z",
"isTemplate": false,
"lineItems": {
"pagination": {
"limit": 100,
"cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
"nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
},
"results": [
{
"id": "53811754d3a604966df72247",
"type": "COST_BREAKDOWN",
"description": "Duct Insulation",
"section": "Furnish & Install",
"isRequired": true,
"unit": "HOURS",
"code": "D2",
"quantity": 1000,
"isQuantityFixed": true,
"external": {
"id": "ext-cost-id-123",
"name": "External Cost Code"
}
}
]
}
}